package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.controller.AssociationController;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.Contributor;
import ch.unige.aou.model.publication.Publication;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.rest.UrlPath;

@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_PUBLICATIONS + SolidifyConstants.URL_PARENT_ID + ResourceName.CONTRIBUTORS)
public class PublicationContributorController extends AssociationController<Publication, Contributor> {
  
  @Override
  protected String getParentFieldName() {
    return "publications";
  }

  @Override
  protected boolean addChildOnParent(Publication publication, Contributor contributor) {
    return publication.addContributor(contributor);
  }

  @Override
  protected boolean removeChildFromParent(Publication publication, Contributor contributor) {
    return publication.removeContributor(contributor);
  }

}
