package ch.unige.aou.service.access;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.rest.ActionName;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.oai.OAISet;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.ResourceClientService;

@Service
public class OAISetClientService extends ResourceClientService<OAISet> implements OAISetClientServiceInterface {

  private static final String OAI_SET_PATH = SolidifyConstants.URL_SEP + ResourceName.OAI_SETS;

  public OAISetClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(OAI_SET_PATH, OAISet.class, ModuleName.ACCESS, restClientTool, env);
  }

  @Override
  public List<OAISet> findAll() {
    return this.findAll(OAISet.class);
  }

  @Override
  public OAISet save(String resId) {
    return this.doActionOnId(resId, ActionName.SAVE);
  }

  @Override
  public List<OAISet> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, OAISet.class);
  }
}
