package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.publication.Contributor;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.ResourceClientService;

@Service
public class ContributorClientService extends ResourceClientService<Contributor> implements ContributorClientServiceInterface {

  public ContributorClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyConstants.URL_SEP + ResourceName.CONTRIBUTORS, Contributor.class, ModuleName.ADMIN, restClientTool, env);
  }

  @Override
  public List<Contributor> findAll() {
    return super.findAll(Contributor.class);
  }

  @Override
  public List<Contributor> searchByProperties(Map<String, String> properties) {
    return super.searchByProperties(properties, Contributor.class);
  }
}
