package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.notification.Event;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.ResourceClientService;

@Service
public class EventClientService extends ResourceClientService<Event> implements EventClientServiceInterface{
  public EventClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyConstants.URL_SEP + ResourceName.EVENTS, Event.class, ModuleName.ADMIN, restClientTool, env);
  }

  @Override
  public List<Event> findAll() {
    return this.findAll(Event.class);
  }

  @Override
  public List<Event> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, Event.class);
  }
}
