package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import com.fasterxml.jackson.databind.ObjectMapper;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.display.StructureValidationRight;
import ch.unige.aou.model.settings.GlobalBanner;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.ResourceClientService;

@Service
public class GlobalBannerClientService extends ResourceClientService<GlobalBanner> implements GlobalBannerClientServiceInterface {

  public GlobalBannerClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyConstants.URL_SEP + ResourceName.GLOBAL_BANNERS, GlobalBanner.class, ModuleName.ADMIN, restClientTool, env);
  }

  @Override
  public List<GlobalBanner> findAll() {
    return this.findAll(GlobalBanner.class);
  }

  public GlobalBanner getActive() {
    final String url = this.getBaseUrl() + this.resourcePath + SolidifyConstants.URL_SEP + AouActionName.GET_ACTIVE;
    final RestTemplate restTemplate = this.restClientTool.getClient();
    return restTemplate.getForObject(url, GlobalBanner.class);
  }

  @Override
  public List<GlobalBanner> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, GlobalBanner.class);
  }
}
