package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.rest.CollectionPage;
import ch.unige.solidify.util.AbstractRestClientTool;
import ch.unige.solidify.util.CollectionTool;

import ch.unige.aou.model.settings.Language;
import ch.unige.aou.model.settings.LanguageDTO;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.ResourceClientService;

@Service
public class LanguageClientService extends ResourceClientService<Language> implements LanguageServiceInterface {

  public LanguageClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyConstants.URL_SEP + ResourceName.LANGUAGES, Language.class, ModuleName.ADMIN, restClientTool, env);
  }

  @Override
  public List<Language> findAll() {
    return super.findAll(Language.class);
  }

  public List<LanguageDTO> listAll() {
    final String url = this.getBaseUrl() + this.resourcePath + "?size=" + CollectionPage.MAX_SIZE_PAGE;
    final RestTemplate restTemplate = this.restClientTool.getClient();
    final String jsonString = restTemplate.getForObject(url, String.class);
    return CollectionTool.getList(jsonString, LanguageDTO.class);
  }

  @Override
  public List<Language> searchByProperties(Map<String, String> properties) {
    return super.searchByProperties(properties, Language.class);
  }
}
