package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.config.TestUserProperties;
import ch.unige.aou.model.security.User;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.ResourceClientService;

@Service
public class UserClientService extends ResourceClientService<User> implements UserClientServiceInterface {

  private static final String USER_PATH = SolidifyConstants.URL_SEP + ResourceName.USERS;

  @Autowired
  private TestUserProperties properties;

  /********************************/

  public UserClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(USER_PATH, User.class, ModuleName.ADMIN, restClientTool, env);
  }

  /********************************/

  @Override
  public List<User> findAll() {
    return this.findAll(User.class);
  }

  @Override
  public User getAuthenticatedUser() {
    return this.doAction(AouActionName.AUTHENTICATED);
  }

  @Override
  public List<User> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, User.class);
  }

}
