package ch.unige.aou.exception;

import java.time.LocalDateTime;
import java.util.Map;

import org.springframework.http.HttpStatus;

import ch.unige.solidify.exception.SolidifyRuntimeException;

public class AouRuntimeException extends SolidifyRuntimeException {
  private static final long serialVersionUID = -4223693183183404502L;

  private int code;
  private final AouError aouError = new AouError();

  public int getCode() {
    return code;
  }

  public void setCode(int code) {
    this.code = code;
  }

  public AouRuntimeException(HttpStatus httpStatus, String message, int code, Map<Object, Object> params) {
    super(message);
    this.code = code;
    this.aouError.setError(httpStatus.toString());
    this.aouError.setMessage(message);
    this.aouError.setStatus(httpStatus);
    this.aouError.setTimeStamp(LocalDateTime.now().toString());
    this.aouError.setAdditionalParameters(params);
    this.aouError.setErrorCode(code);
  }

  public AouError getAouError() {
    return this.aouError;
  }

}
