package ch.unige.aou.model;

import javax.persistence.Column;
import javax.persistence.Lob;
import javax.persistence.MappedSuperclass;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonIgnore;

@MappedSuperclass
public abstract class Image extends AouResourceNormalized<Image> {

  @JsonIgnore
  @Lob
  @NotNull
  private byte[] image;

  @Column(length = 2024)
  private String fileName;

  private Long fileSize;

  private String mimeType;

  public Image() {
  }

  public void setImage(byte[] image) {
    this.image = image;
  }

  public void setFileSize(Long fileSize) {
    this.fileSize = fileSize;
  }

  public void setFileName(String fileName) {
    this.fileName = fileName;
  }

  public void setMimeType(String mimeType) {
    this.setCurrentProperty(mimeType);
  }

  public byte[] getImage() {
    return this.image;
  }

  public Long getFileSize() {
    return this.fileSize;
  }

  public String getFileName() {
    return this.fileName;
  }

  public String getMimeType() {
    return this.mimeType;
  }
}
