package ch.unige.aou.model.publication;

import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToMany;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import com.fasterxml.jackson.annotation.JsonIgnore;

import ch.unige.aou.model.AouResourceNormalized;

@Entity
public class Contributor extends AouResourceNormalized<Contributor> {

  private String firstName;

  @NotNull
  @Size(min = 1)
  private String lastName;

  @Size(min = 1)
  @Column(unique = true)
  private String cnIndividu;

  @JsonIgnore
  @ManyToMany(mappedBy = "contributors")
  private Set<Publication> publications = new HashSet<>();

  /****************************************************************/

  public String getFirstName() {
    return this.firstName;
  }

  public String getLastName() {
    return this.lastName;
  }

  public String getCnIndividu() {
    return this.cnIndividu;
  }

  public Set<Publication> getPublications() {
    return this.publications;
  }

  /****************************************************************/

  public void setLastName(String lastname) {
    this.setCurrentProperty(lastname);
  }

  public void setFirstName(String firstname) {
    this.setCurrentProperty(firstname);
  }

  public void setCnIndividu(String cnIndividu) {
    this.setCurrentProperty(cnIndividu);
  }

  public void setPublications(Set<Publication> publications) {
    this.setCurrentProperty(publications);
  }
}
