package ch.unige.aou.model.publication;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import ch.unige.aou.model.settings.Label;

public class PublicationSubtypeContributorRoleDTO implements Serializable {

  private int sortValue;
  private String value;
  private String contributorRoleId;
  private String publicationSubtypeId;
  private List<Label> labels = new ArrayList<>();

  public PublicationSubtypeContributorRoleDTO() {
  }

  public PublicationSubtypeContributorRoleDTO(PublicationSubtypeContributorRole subtypeDocFile) {
    this.sortValue = subtypeDocFile.getSortValue();

    if (subtypeDocFile.getContributorRole() != null) {
      this.value = subtypeDocFile.getContributorRole().getValue();
      this.labels.addAll(subtypeDocFile.getContributorRole().getLabels());
    }

    if (subtypeDocFile.getContributorRole() != null) {
      this.contributorRoleId = subtypeDocFile.getContributorRole().getResId();
    }

    if (subtypeDocFile.getPublicationSubtype() != null) {
      this.publicationSubtypeId = subtypeDocFile.getPublicationSubtype().getResId();
    }
  }

  public String getValue() {
    return this.value;
  }

  public int getSortValue() {
    return this.sortValue;
  }

  public String getPublicationSubtypeId() {
    return this.publicationSubtypeId;
  }

  public List<Label> getLabels() {
    return this.labels;
  }

  public String getContributorRoleId() {
    return this.contributorRoleId;
  }
}
