package ch.unige.aou.model.settings;

import javax.persistence.Entity;
import javax.persistence.Transient;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;

import ch.unige.solidify.rest.ResourceNormalized;
import ch.unige.solidify.util.ReflectionTool;

import ch.unige.aou.rest.ModuleName;

@Entity
public class DownloadToken extends ResourceNormalized<DownloadToken> {

  private String userId;

  private String archiveId;

  @JsonIgnore
  private String tokenHash;

  @Transient
  @JsonInclude
  private String token;

  public DownloadToken() {
    // no-op
  }

  public DownloadToken(String userId, String archiveId, String tokenHash, String token) {
    this.userId = userId;
    this.archiveId = archiveId;
    this.tokenHash = tokenHash;
    this.token = token;
  }

  public String getUserId() {
    return this.userId;
  }

  public void setUserId(String userId) {
    this.setProperty(ReflectionTool.getCurrentSetterVariableName(), userId);
  }

  public String getArchiveId() {
    return this.archiveId;
  }

  public void setArchiveId(String archiveId) {
    this.setProperty(ReflectionTool.getCurrentSetterVariableName(), archiveId);
  }

  public String getTokenHash() {
    return this.tokenHash;
  }

  public void setTokenHash(String tokenHash) {
    this.tokenHash = tokenHash;
  }

  public String getToken() {
    return this.token;
  }

  public void setToken(String token) {
    this.token = token;
  }

  @Override
  public void init() {

  }

  @Override
  public String managedBy() {
    return ModuleName.ADMIN;
  }
}
