package ch.unige.aou.model.xml.deposit.v1.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;

import ch.unige.solidify.exception.SolidifyRuntimeException;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v1.Dois;

public class DoisDeserializer extends AouStdDeserializer<Dois> {

  private static final long serialVersionUID = 659865L;

  @Override
  public Dois deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    if (jsonNode instanceof ArrayNode) {
      if (jsonNode.isEmpty()) {
        return null;
      }

      Dois dois = new Dois();
      jsonNode.forEach(doiNode -> {
        JsonNode valueNode = doiNode.get("doi");
        if (this.nodeHasTextValue(valueNode)) {
          dois.getDoi().add(valueNode.textValue());
        }
      });
      return dois;

    } else {
      throw new SolidifyRuntimeException("dois is not an array");
    }
  }
}
