package ch.unige.aou.model.xml.deposit.v1.serializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import ch.unige.aou.model.xml.deposit.v1.DepositIdentifiers;

public class DepositIdentifiersSerializer extends StdSerializer<DepositIdentifiers> {
  public DepositIdentifiersSerializer() {
    this(null);
  }

  public DepositIdentifiersSerializer(Class<DepositIdentifiers> t) {
    super(t);
  }

  @Override
  public void serialize(DepositIdentifiers value, JsonGenerator jgen, SerializerProvider provider)
          throws IOException, JsonProcessingException {
    jgen.writeStartObject();
    jgen.writeStringField("arxiv", value.getArxiv());
    jgen.writeStringField("dblp", value.getDblp());
    jgen.writeObjectField("dois", value.getDois());
    jgen.writeStringField("isbn", value.getIsbn());
    jgen.writeStringField("localNumber", value.getLocalNumber());
    String pmid = null;
    if (value.getPmid() != null) {
      pmid = value.getPmid().toString();
    }
    jgen.writeStringField("pmid", pmid);
    jgen.writeStringField("repec", value.getRepec());
    jgen.writeStringField("rero", value.getRero());
    jgen.writeStringField("urn", value.getUrn());
    jgen.writeEndObject();
  }
}
