package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.publication.Comment;

public class CommentSpecification extends SolidifySpecification<Comment> {

    public CommentSpecification(Comment criteria) {
        super(criteria);
    }

    @Override
    protected void completePredicatesList(Root<Comment> root, CriteriaQuery<?> query, CriteriaBuilder builder, List<Predicate> predicatesList) {
        if (this.criteria.getPublication() != null) {
            predicatesList.add(builder.like(root.get("publication").get("resId"), this.criteria.getPublication().getResId()));
        }
        if (this.criteria.getText() != null) {
            predicatesList.add(builder.like(root.get("text"), "%" + this.criteria.getText() + "%"));
        }
        if (this.criteria.hasOnlyForValidatorValue()) {
            if (this.criteria.isOnlyForValidators()) {
                predicatesList.add(builder.isTrue(root.get("onlyForValidators")));
            } else {
                predicatesList.add(builder.isFalse(root.get("onlyForValidators")));
            }
        }
    }

}
