package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.notification.EventType;

public class EventTypeSpecification extends SolidifySpecification<EventType> {
  private static final long serialVersionUID = -9120399205173630014L;

  public EventTypeSpecification(EventType criteria) {
    super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<EventType> root, CriteriaQuery<?> query, CriteriaBuilder builder, List<Predicate> predicatesList) {
    if (this.criteria.getName() != null) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }
  }
}
