package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.settings.GlobalBanner;
import ch.unige.aou.model.settings.Language;

public class GlobalBannerSpecification extends SolidifySpecification<GlobalBanner> {
  private static final long serialVersionUID = -9215675545265165685L;

  public GlobalBannerSpecification(GlobalBanner globalBanner) {
    super(globalBanner);
  }

  @Override
  protected void completePredicatesList(Root<GlobalBanner> root, CriteriaQuery<?> query, CriteriaBuilder builder, List<Predicate> predicatesList) {
    if (this.criteria.getName() != null) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }
    if (this.criteria.getType() != null) {
      predicatesList.add(builder.equal(root.get("type"), this.criteria.getType()));
    }
    if (this.criteria.getEnabled() != null) {
      predicatesList.add(builder.equal(root.get("enabled"), this.criteria.getEnabled()));
    }
  }
}
