package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.settings.Language;

public class LanguageSpecification extends SolidifySpecification<Language> {
  private static final long serialVersionUID = -3553409253872777435L;

  public LanguageSpecification(Language language) {
    super(language);
  }

  @Override
  protected void completePredicatesList(Root<Language> root, CriteriaQuery<?> query, CriteriaBuilder builder, List<Predicate> predicatesList) {
    if (this.criteria.getCode() != null) {
      predicatesList.add(builder.like(root.get("code"), "%" + this.criteria.getCode() + "%"));
    }
  }
}
