package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.publication.PublicationSubSubtype;

public class PublicationSubSubtypeSpecification extends SolidifySpecification<PublicationSubSubtype> {
  private static final long serialVersionUID = 8504672467150246639L;

  public PublicationSubSubtypeSpecification(PublicationSubSubtype criteria) {
   super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<PublicationSubSubtype> root, CriteriaQuery<?> query, CriteriaBuilder builder,
          List<Predicate> predicatesList) {
    if (this.criteria.getName() != null) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }
    if (this.criteria.getSortValue() != null) {
      predicatesList.add(builder.equal(root.get("sortValue"), this.criteria.getSortValue()));
    }
    if (this.criteria.getPublicationSubtype() != null && this.criteria.getPublicationSubtype().getResId() != null) {
      predicatesList.add(builder.equal(root.get("publicationSubtype").get("resId"), this.criteria.getPublicationSubtype().getResId()));
    }
  }
}
