package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.schedule.ScheduledTask;

public class ScheduledTaskSpecification extends SolidifySpecification<ScheduledTask> {

  public ScheduledTaskSpecification(ScheduledTask criteria) {
    super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<ScheduledTask> root, CriteriaQuery<?> query, CriteriaBuilder builder,
          List<Predicate> predicatesList) {
    if (this.criteria.getName() != null) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }
    if (this.criteria.getTaskType() != null) {
      predicatesList.add(builder.equal(root.get("taskType"), this.criteria.getTaskType()));
    }
    if (this.criteria.getCronExpression() != null) {
      predicatesList.add(builder.like(root.get("cronExpression"), "%" + this.criteria.getCronExpression() + "%"));
    }
  }
}
