package ch.unige.aou.test.dto;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.Test;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;

import ch.unige.aou.model.rest.UnigePersonDTO;

class UnigePersonDTOTest {

  @Test
  void dtoTest() throws JsonProcessingException {
    String json = "{ \"firstname\" : \"JEAN-CLAUDE VAN DAMME\"," +
                    "\"lastname\" : \"A\"," +
                    "\"birth\" : \"1999-11-11\"," +
                    "\"indicators\" : { \"isCollab\" : true } } ";
    ObjectMapper objectMapper = new ObjectMapper();
    JsonNode jsonNode = objectMapper.readTree(json);
    UnigePersonDTO dto = new UnigePersonDTO(jsonNode);
    assertEquals("Jean-Claude Van Damme", dto.getFirstname());
    assertEquals("A", dto.getLastname());
    assertEquals(true, dto.isEmployee());
    assertEquals(1999, dto.getYearOfBirth());
  }

}
