package ch.unige.aou.task;

import java.util.List;

import ch.unige.aou.business.NotificationService;
import ch.unige.aou.business.ScheduledTaskService;
import ch.unige.aou.message.EmailMessage;
import ch.unige.aou.model.notification.Notification;
import ch.unige.aou.model.notification.NotificationType;
import ch.unige.aou.model.publication.Publication;
import ch.unige.aou.model.schedule.ScheduledTask;

public class NotifyValidatorsOnCommentsTask extends AbstractTaskRunnable {

  public NotifyValidatorsOnCommentsTask(ScheduledTaskService scheduledTaskService, ScheduledTask scheduledTask,
          NotificationService notificationService, TaskExecutorService taskExecutorService) {
    super(scheduledTaskService, scheduledTask, notificationService, taskExecutorService);
  }

  @Override
  protected void executeTask() {
    List<Notification> notificationsToSend = this.getNotificationsToSend(NotificationType.PUBLICATION_TO_VALIDATE_COMMENTED);
    if (!notificationsToSend.isEmpty()) {
      this.taskExecutorService.getNotificationsAndSendEmails(notificationsToSend,
              List.of(Publication.PublicationStatus.IN_VALIDATION, Publication.PublicationStatus.FEEDBACK_REQUIRED,
                      Publication.PublicationStatus.REJECTED, Publication.PublicationStatus.IN_ERROR, Publication.PublicationStatus.SUBMITTED,
                      Publication.PublicationStatus.COMPLETED),
              NotificationType.PUBLICATION_TO_VALIDATE_COMMENTED,
              EmailMessage.EmailTemplate.NEW_COMMENT_FOR_VALIDATORS_DEPOSIT);
    }
  }

}
