package ch.unige.aou.test.resource;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.springframework.restdocs.payload.FieldDescriptor;

import ch.unige.solidify.test.helper.AbstractResourceDoc;
import ch.unige.solidify.test.helper.FieldDescriptorBuilder;
import ch.unige.solidify.test.model.TypeField;

import ch.unige.aou.rest.UrlPath;

public class ModuleDoc extends AbstractResourceDoc {

  @Override
  public List<String> getListLinks() {
    return new ArrayList<>();
  }

  @Override
  public String getName() {
    return UrlPath.ADMIN_MODULES;
  }

  @Override
  public List<String> getResourceLinks() {
    return new ArrayList<>();
  }

  @Override
  protected List<FieldDescriptor> getDocumentationFields() {
    // @formatter:off
    final List<FieldDescriptor> documentationFields = new ArrayList<>(Arrays.asList(
      new FieldDescriptorBuilder(this)
        .name("authorization")
        .description("The URL of _authoriration_ module")
        .type(TypeField.STRING)
        .build(),
      new FieldDescriptorBuilder(this)
        .name("admin")
        .description("The URL of _admin_ module")
        .type(TypeField.STRING)
        .build(),
      new FieldDescriptorBuilder(this)
        .name("access")
        .description("The URL of _access_ module")
        .type(TypeField.STRING)
        .build()
    ));
    // @formatter:on
    return documentationFields;
  }

  @Override
  public List<String> getCommonResourceFields() {
    return new ArrayList<>();
  }

  @Override
  public boolean isNormalResource() {
    return false;
  }
}
