package ch.unige.aou.test.resource;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.springframework.restdocs.payload.FieldDescriptor;

import ch.unige.solidify.test.helper.AbstractResourceDoc;
import ch.unige.solidify.test.helper.FieldDescriptorBuilder;
import ch.unige.solidify.test.model.TypeField;

public class PublicationTypeDTODoc extends AbstractResourceDoc {
  @Override
  public List<String> getListLinks() {
    return Collections.emptyList();
  }

  @Override
  public String getName() {
    return "publication-type-dto";
  }

  @Override
  public List<String> getResourceLinks() {
    return Collections.emptyList();
  }

  @Override
  protected List<FieldDescriptor> getDocumentationFields() {
    return this.getDocumentationFields(null);
  }

  protected List<FieldDescriptor> getDocumentationFields(String prefix) {
    // @formatter:off
    final List<FieldDescriptor> documentationFields =  new ArrayList<>(Arrays.asList(
      new FieldDescriptorBuilder(this)
        .name(prefix + ".type.resId")
        .description("Id of the subtype")
        .mandatory(true)
        .type(TypeField.STRING)
        .testValue("A1")
        .build(),
      new FieldDescriptorBuilder(this)
        .name(prefix + ".type.name")
        .description("Name of the subtype")
        .mandatory(true)
        .type(TypeField.STRING)
        .build()
    ));
    // @formatter:on

    return documentationFields;
  }
}
