package ch.unige.aou.test.resource;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.springframework.restdocs.payload.FieldDescriptor;

import ch.unige.solidify.test.helper.AbstractResourceDoc;
import ch.unige.solidify.test.helper.FieldDescriptorBuilder;
import ch.unige.solidify.test.model.TypeField;

import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.rest.UrlPath;

public class PublicationTypeDoc extends AbstractResourceDoc {

  @Override
  public List<String> getListLinks() {
    return Collections.emptyList();
  }

  @Override
  public String getName() {
    return UrlPath.ADMIN_PUBLICATION_TYPES;
  }

  @Override
  public List<String> getResourceLinks() {
    return Arrays.asList(ResourceName.PUBLICATION_SUBTYPES);
  }

  @Override
  protected List<FieldDescriptor> getDocumentationFields() {
    // @formatter:off
    return Arrays.asList(
      new FieldDescriptorBuilder(this)
        .name("name")
        .description("The name of the publication type")
        .mandatory(true)
        .type(TypeField.STRING)
        .build(),
      new FieldDescriptorBuilder(this)
        .name("sortValue")
        .description("The sort value of the publication type")
        .mandatory(true)
        .type(TypeField.INT32)
        .testValue("10")
        .build()
    );
    // @formatter:on
  }

}
